import YvanDesigner from "@/components/YvanDesigner.vue";
import {createRouter, createWebHashHistory, RouteRecordRaw} from 'vue-router';
/** 获取路由数据 */
function getRoutes(): RouteRecordRaw[] {
    const routes = [];
    routes.push({path: "/", component: YvanDesigner})
    routes.push({path: "/designer/:printTemplateId", component: YvanDesigner})
    return routes;
}

/** 全局的路由对象 */
const router = createRouter({
    history: createWebHashHistory(),
    routes: [],
    strict: true,
    sensitive: true,
});

/** 删除路由的钩子函数 */
const removeRoutesFuc: Array<() => void> = [];

/** 初始化路由 */
function initRouter() {
    const routes = getRoutes();
    removeRoutesFuc.forEach(removeRoute => removeRoute());
    removeRoutesFuc.length = 0;
    routes.forEach(route => removeRoutesFuc.push(router.addRoute(route)));
}

initRouter()

export {
    router,
};
