import toast from '@/utils/toast'

const swap = (arr, i, j) => {
    const temp = arr[i]
    arr[i] = arr[j]
    arr[j] = temp
}

export default {
    actions: {
        upComponent() {
            const {componentData, curComponentIndex} = this
            // 上移图层 index，表示元素在数组中越往后
            if (curComponentIndex < componentData.length - 1) {
                swap(componentData, curComponentIndex, curComponentIndex + 1)
                this.curComponentIndex = curComponentIndex + 1
            } else {
                toast('已经到顶了')
            }
        },

        downComponent() {
            const {componentData, curComponentIndex} = this
            // 下移图层 index，表示元素在数组中越往前
            if (curComponentIndex > 0) {
                swap(componentData, curComponentIndex, curComponentIndex - 1)
                this.curComponentIndex = curComponentIndex - 1
            } else {
                toast('已经到底了')
            }
        },

        topComponent() {
            const {componentData, curComponentIndex, curComponent} = this
            // 置顶
            if (curComponentIndex < componentData.length - 1) {
                componentData.splice(curComponentIndex, 1)
                componentData.push(curComponent)
                this.curComponentIndex = componentData.length - 1
            } else {
                toast('已经到顶了')
            }
        },

        bottomComponent() {
            const {componentData, curComponentIndex, curComponent} = this
            // 置底
            if (curComponentIndex > 0) {
                componentData.splice(curComponentIndex, 1)
                componentData.unshift(curComponent)
                this.curComponentIndex = 0
            } else {
                toast('已经到底了')
            }
        }
    },
}
