import Big from 'big.js'
import {defineStore} from "pinia";
import {globalStore} from "@/store/global";
import CONSTANT from '@/utils/constant';

const {MIN_SCALE, MAX_SCALE} = CONSTANT


export const ruleStore = defineStore('ruleThings', {
    state: () => ({
        scale: 1,
        rectWidth: globalStore().getPageConfig.pageWidth,
        rectHeight: globalStore().getPageConfig.pageHeight,
        needReDrawRuler: 0,
        showRuler: true
    }),
    actions: {
        setScale(nextScale) {
            let nextScaleBig = new Big(nextScale)
            // this.scale = new Big(nextScaleBig).times(new Big(5)).toNumber()
            this.scale = new Big(nextScaleBig).toNumber()
        },
        setBiggerScale() {
            let currentScaleTime5 = new Big(this.scale)
            // let currentScale = currentScaleTime5.div(new Big(5))
            let currentScale = currentScaleTime5
            let stepScale = new Big(0.1)
            let nextScale = currentScale.plus(stepScale).toNumber()
            let myNextScale = nextScale > MAX_SCALE ? MAX_SCALE : nextScale
            // this.scale = new Big(myNextScale).times(new Big(5)).toNumber()
            this.scale = new Big(myNextScale).toNumber()
        },
        setSmallerScale() {
            let currentScaleTime5 = new Big(this.scale)
            // let currentScale = currentScaleTime5.div(new Big(5))
            let currentScale = currentScaleTime5
            let stepScale = new Big(0.1)
            let nextScale = currentScale.minus(stepScale).toNumber()
            let myNextScale = nextScale < MIN_SCALE ? MIN_SCALE : nextScale
            // this.scale = new Big(myNextScale).times(new Big(5)).toNumber()
            this.scale = new Big(myNextScale).toNumber()
        },
        setReDrawRuler() {
            this.needReDrawRuler += 1
        },
        setRect({pageWidth, pageHeight}) {
            this.rectWidth = pageWidth
            this.rectHeight = pageHeight
        },
        rotateRect() {
            const tmpHeight = this.rectHeight
            this.rectHeight = Number(this.rectWidth)
            this.rectWidth = Number(tmpHeight)
        },
        toggleRuler() {
            this.showRuler = !this.showRuler
        }
    }
})
