import {globalStore} from "@/store";
import Constant from "@/utils/constant";
import {elementBands} from "@/components/config/globalConfig";

export default class ElementUtils {

    /**
     * 获取元素Band的索引
     * @param elementBandCode
     */
    public static getElementBandIdx(elementBandCode): Number {
        return elementBands.findLastIndex(band => band.code === elementBandCode)
    }

    /**
     * 从GlobalStore中获取元素Band对象
     * @param elementBandCode
     */
    public static getElementBandFromStore(elementBandCode) {
        return globalStore().elementBands.get(elementBandCode)
    }

    public static isFirstElementBandCode(elementBandCode) {
        return globalStore().getElementBandCodes().findLastIndex((bandCode) => bandCode === elementBandCode) === 0
    }

    public static initElementBandCode() {
        const elementBands = ElementUtils.getAllElementBand()
        if (!elementBands) {
            return;
        }
        for (let index in elementBands) {
            // const elementBand = elementBands[index];
            globalStore().setElementBandCode({
                elementBandIdx: index,
                elementBandCode: Constant.NONE
            });
        }
    }

    public static getAllElementBand() {
        return elementBands;
    }
}