export default class UnitConverter {

    public static getDPI() {
        const arrDPI = new Array;
        if (window.screen.deviceXDPI) {
            arrDPI[0] = window.screen.deviceXDPI;
            arrDPI[1] = window.screen.deviceYDPI;
            return arrDPI;
        } else {
            const tmpNode = document.createElement("DIV");
            tmpNode.style.cssText = "width:1in;height:1in;position:absolute;left:0px;top:0px;z-index:99;visibility:hidden";
            document.body.appendChild(tmpNode);
            arrDPI[0] = parseInt(String(tmpNode.offsetWidth));
            arrDPI[1] = parseInt(String(tmpNode.offsetHeight));
            tmpNode.parentNode.removeChild(tmpNode);
        }
        return arrDPI;
    }

    /**
     * px转换为mm
     * @param value
     * @param isX
     * @returns {number}
     */
    public static px2Mm(value, isX): number {
        const inch = value / UnitConverter.getDPI()[isX ? 0 : 1];
        return inch * 25.4;
    };

    /**
     * mm转换为px
     * @param value
     * @param isX
     * @returns {number}
     */
    public static mm2Px(value, isX): number {
        const inch = value / 25.4;
        return inch * UnitConverter.getDPI()[isX ? 0 : 1];
    }
}